/*******************************************************************************
* File Name: Pin_ADCIn.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Pin_ADCIn_H) /* Pins Pin_ADCIn_H */
#define CY_PINS_Pin_ADCIn_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Pin_ADCIn_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Pin_ADCIn_Write(uint8 value) ;
void    Pin_ADCIn_SetDriveMode(uint8 mode) ;
uint8   Pin_ADCIn_ReadDataReg(void) ;
uint8   Pin_ADCIn_Read(void) ;
uint8   Pin_ADCIn_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Pin_ADCIn_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Pin_ADCIn_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Pin_ADCIn_DM_RES_UP          PIN_DM_RES_UP
#define Pin_ADCIn_DM_RES_DWN         PIN_DM_RES_DWN
#define Pin_ADCIn_DM_OD_LO           PIN_DM_OD_LO
#define Pin_ADCIn_DM_OD_HI           PIN_DM_OD_HI
#define Pin_ADCIn_DM_STRONG          PIN_DM_STRONG
#define Pin_ADCIn_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Pin_ADCIn_MASK               Pin_ADCIn__MASK
#define Pin_ADCIn_SHIFT              Pin_ADCIn__SHIFT
#define Pin_ADCIn_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Pin_ADCIn_PS                     (* (reg8 *) Pin_ADCIn__PS)
/* Data Register */
#define Pin_ADCIn_DR                     (* (reg8 *) Pin_ADCIn__DR)
/* Port Number */
#define Pin_ADCIn_PRT_NUM                (* (reg8 *) Pin_ADCIn__PRT) 
/* Connect to Analog Globals */                                                  
#define Pin_ADCIn_AG                     (* (reg8 *) Pin_ADCIn__AG)                       
/* Analog MUX bux enable */
#define Pin_ADCIn_AMUX                   (* (reg8 *) Pin_ADCIn__AMUX) 
/* Bidirectional Enable */                                                        
#define Pin_ADCIn_BIE                    (* (reg8 *) Pin_ADCIn__BIE)
/* Bit-mask for Aliased Register Access */
#define Pin_ADCIn_BIT_MASK               (* (reg8 *) Pin_ADCIn__BIT_MASK)
/* Bypass Enable */
#define Pin_ADCIn_BYP                    (* (reg8 *) Pin_ADCIn__BYP)
/* Port wide control signals */                                                   
#define Pin_ADCIn_CTL                    (* (reg8 *) Pin_ADCIn__CTL)
/* Drive Modes */
#define Pin_ADCIn_DM0                    (* (reg8 *) Pin_ADCIn__DM0) 
#define Pin_ADCIn_DM1                    (* (reg8 *) Pin_ADCIn__DM1)
#define Pin_ADCIn_DM2                    (* (reg8 *) Pin_ADCIn__DM2) 
/* Input Buffer Disable Override */
#define Pin_ADCIn_INP_DIS                (* (reg8 *) Pin_ADCIn__INP_DIS)
/* LCD Common or Segment Drive */
#define Pin_ADCIn_LCD_COM_SEG            (* (reg8 *) Pin_ADCIn__LCD_COM_SEG)
/* Enable Segment LCD */
#define Pin_ADCIn_LCD_EN                 (* (reg8 *) Pin_ADCIn__LCD_EN)
/* Slew Rate Control */
#define Pin_ADCIn_SLW                    (* (reg8 *) Pin_ADCIn__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Pin_ADCIn_PRTDSI__CAPS_SEL       (* (reg8 *) Pin_ADCIn__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Pin_ADCIn_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Pin_ADCIn__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Pin_ADCIn_PRTDSI__OE_SEL0        (* (reg8 *) Pin_ADCIn__PRTDSI__OE_SEL0) 
#define Pin_ADCIn_PRTDSI__OE_SEL1        (* (reg8 *) Pin_ADCIn__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Pin_ADCIn_PRTDSI__OUT_SEL0       (* (reg8 *) Pin_ADCIn__PRTDSI__OUT_SEL0) 
#define Pin_ADCIn_PRTDSI__OUT_SEL1       (* (reg8 *) Pin_ADCIn__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Pin_ADCIn_PRTDSI__SYNC_OUT       (* (reg8 *) Pin_ADCIn__PRTDSI__SYNC_OUT) 


#if defined(Pin_ADCIn__INTSTAT)  /* Interrupt Registers */

    #define Pin_ADCIn_INTSTAT                (* (reg8 *) Pin_ADCIn__INTSTAT)
    #define Pin_ADCIn_SNAP                   (* (reg8 *) Pin_ADCIn__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Pin_ADCIn_H */


/* [] END OF FILE */
