/*******************************************************************************
* File Name: Pin_DACOut.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Pin_DACOut_H) /* Pins Pin_DACOut_H */
#define CY_PINS_Pin_DACOut_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Pin_DACOut_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Pin_DACOut_Write(uint8 value) ;
void    Pin_DACOut_SetDriveMode(uint8 mode) ;
uint8   Pin_DACOut_ReadDataReg(void) ;
uint8   Pin_DACOut_Read(void) ;
uint8   Pin_DACOut_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Pin_DACOut_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Pin_DACOut_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Pin_DACOut_DM_RES_UP          PIN_DM_RES_UP
#define Pin_DACOut_DM_RES_DWN         PIN_DM_RES_DWN
#define Pin_DACOut_DM_OD_LO           PIN_DM_OD_LO
#define Pin_DACOut_DM_OD_HI           PIN_DM_OD_HI
#define Pin_DACOut_DM_STRONG          PIN_DM_STRONG
#define Pin_DACOut_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Pin_DACOut_MASK               Pin_DACOut__MASK
#define Pin_DACOut_SHIFT              Pin_DACOut__SHIFT
#define Pin_DACOut_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Pin_DACOut_PS                     (* (reg8 *) Pin_DACOut__PS)
/* Data Register */
#define Pin_DACOut_DR                     (* (reg8 *) Pin_DACOut__DR)
/* Port Number */
#define Pin_DACOut_PRT_NUM                (* (reg8 *) Pin_DACOut__PRT) 
/* Connect to Analog Globals */                                                  
#define Pin_DACOut_AG                     (* (reg8 *) Pin_DACOut__AG)                       
/* Analog MUX bux enable */
#define Pin_DACOut_AMUX                   (* (reg8 *) Pin_DACOut__AMUX) 
/* Bidirectional Enable */                                                        
#define Pin_DACOut_BIE                    (* (reg8 *) Pin_DACOut__BIE)
/* Bit-mask for Aliased Register Access */
#define Pin_DACOut_BIT_MASK               (* (reg8 *) Pin_DACOut__BIT_MASK)
/* Bypass Enable */
#define Pin_DACOut_BYP                    (* (reg8 *) Pin_DACOut__BYP)
/* Port wide control signals */                                                   
#define Pin_DACOut_CTL                    (* (reg8 *) Pin_DACOut__CTL)
/* Drive Modes */
#define Pin_DACOut_DM0                    (* (reg8 *) Pin_DACOut__DM0) 
#define Pin_DACOut_DM1                    (* (reg8 *) Pin_DACOut__DM1)
#define Pin_DACOut_DM2                    (* (reg8 *) Pin_DACOut__DM2) 
/* Input Buffer Disable Override */
#define Pin_DACOut_INP_DIS                (* (reg8 *) Pin_DACOut__INP_DIS)
/* LCD Common or Segment Drive */
#define Pin_DACOut_LCD_COM_SEG            (* (reg8 *) Pin_DACOut__LCD_COM_SEG)
/* Enable Segment LCD */
#define Pin_DACOut_LCD_EN                 (* (reg8 *) Pin_DACOut__LCD_EN)
/* Slew Rate Control */
#define Pin_DACOut_SLW                    (* (reg8 *) Pin_DACOut__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Pin_DACOut_PRTDSI__CAPS_SEL       (* (reg8 *) Pin_DACOut__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Pin_DACOut_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Pin_DACOut__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Pin_DACOut_PRTDSI__OE_SEL0        (* (reg8 *) Pin_DACOut__PRTDSI__OE_SEL0) 
#define Pin_DACOut_PRTDSI__OE_SEL1        (* (reg8 *) Pin_DACOut__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Pin_DACOut_PRTDSI__OUT_SEL0       (* (reg8 *) Pin_DACOut__PRTDSI__OUT_SEL0) 
#define Pin_DACOut_PRTDSI__OUT_SEL1       (* (reg8 *) Pin_DACOut__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Pin_DACOut_PRTDSI__SYNC_OUT       (* (reg8 *) Pin_DACOut__PRTDSI__SYNC_OUT) 


#if defined(Pin_DACOut__INTSTAT)  /* Interrupt Registers */

    #define Pin_DACOut_INTSTAT                (* (reg8 *) Pin_DACOut__INTSTAT)
    #define Pin_DACOut_SNAP                   (* (reg8 *) Pin_DACOut__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Pin_DACOut_H */


/* [] END OF FILE */
