/*******************************************************************************
* File Name: Pin_Switch.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Pin_Switch_H) /* Pins Pin_Switch_H */
#define CY_PINS_Pin_Switch_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Pin_Switch_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Pin_Switch_Write(uint8 value) ;
void    Pin_Switch_SetDriveMode(uint8 mode) ;
uint8   Pin_Switch_ReadDataReg(void) ;
uint8   Pin_Switch_Read(void) ;
uint8   Pin_Switch_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Pin_Switch_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Pin_Switch_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Pin_Switch_DM_RES_UP          PIN_DM_RES_UP
#define Pin_Switch_DM_RES_DWN         PIN_DM_RES_DWN
#define Pin_Switch_DM_OD_LO           PIN_DM_OD_LO
#define Pin_Switch_DM_OD_HI           PIN_DM_OD_HI
#define Pin_Switch_DM_STRONG          PIN_DM_STRONG
#define Pin_Switch_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Pin_Switch_MASK               Pin_Switch__MASK
#define Pin_Switch_SHIFT              Pin_Switch__SHIFT
#define Pin_Switch_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Pin_Switch_PS                     (* (reg8 *) Pin_Switch__PS)
/* Data Register */
#define Pin_Switch_DR                     (* (reg8 *) Pin_Switch__DR)
/* Port Number */
#define Pin_Switch_PRT_NUM                (* (reg8 *) Pin_Switch__PRT) 
/* Connect to Analog Globals */                                                  
#define Pin_Switch_AG                     (* (reg8 *) Pin_Switch__AG)                       
/* Analog MUX bux enable */
#define Pin_Switch_AMUX                   (* (reg8 *) Pin_Switch__AMUX) 
/* Bidirectional Enable */                                                        
#define Pin_Switch_BIE                    (* (reg8 *) Pin_Switch__BIE)
/* Bit-mask for Aliased Register Access */
#define Pin_Switch_BIT_MASK               (* (reg8 *) Pin_Switch__BIT_MASK)
/* Bypass Enable */
#define Pin_Switch_BYP                    (* (reg8 *) Pin_Switch__BYP)
/* Port wide control signals */                                                   
#define Pin_Switch_CTL                    (* (reg8 *) Pin_Switch__CTL)
/* Drive Modes */
#define Pin_Switch_DM0                    (* (reg8 *) Pin_Switch__DM0) 
#define Pin_Switch_DM1                    (* (reg8 *) Pin_Switch__DM1)
#define Pin_Switch_DM2                    (* (reg8 *) Pin_Switch__DM2) 
/* Input Buffer Disable Override */
#define Pin_Switch_INP_DIS                (* (reg8 *) Pin_Switch__INP_DIS)
/* LCD Common or Segment Drive */
#define Pin_Switch_LCD_COM_SEG            (* (reg8 *) Pin_Switch__LCD_COM_SEG)
/* Enable Segment LCD */
#define Pin_Switch_LCD_EN                 (* (reg8 *) Pin_Switch__LCD_EN)
/* Slew Rate Control */
#define Pin_Switch_SLW                    (* (reg8 *) Pin_Switch__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Pin_Switch_PRTDSI__CAPS_SEL       (* (reg8 *) Pin_Switch__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Pin_Switch_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Pin_Switch__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Pin_Switch_PRTDSI__OE_SEL0        (* (reg8 *) Pin_Switch__PRTDSI__OE_SEL0) 
#define Pin_Switch_PRTDSI__OE_SEL1        (* (reg8 *) Pin_Switch__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Pin_Switch_PRTDSI__OUT_SEL0       (* (reg8 *) Pin_Switch__PRTDSI__OUT_SEL0) 
#define Pin_Switch_PRTDSI__OUT_SEL1       (* (reg8 *) Pin_Switch__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Pin_Switch_PRTDSI__SYNC_OUT       (* (reg8 *) Pin_Switch__PRTDSI__SYNC_OUT) 


#if defined(Pin_Switch__INTSTAT)  /* Interrupt Registers */

    #define Pin_Switch_INTSTAT                (* (reg8 *) Pin_Switch__INTSTAT)
    #define Pin_Switch_SNAP                   (* (reg8 *) Pin_Switch__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Pin_Switch_H */


/* [] END OF FILE */
